<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

defined('_JEXEC') or die('Restricted access');

use Joomla\Registry\Registry;

class JaMegafilterModelCron extends JModelForm {
	
	public function getForm($data = array(), $loadData = true) {
		$form = $this->loadForm('com_jamegafilter.cron', 'cron', array('control' => 'jform', 'load_data' => $loadData));
		return $form;
	}
	
	function save($new_cron = false, $reset_last_cron = false) {
		$app = JFactory::getApplication();
		$input = $app->input;
		$data = $input->get('jform', array(), 'registry');
		$data = new Registry($data);
		$time = $data->get('time');
		if (!$time) {
			$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_MISSING_TIME'), 'error');
			return false;
		}
		
		$fids = $data->get('fids');
		if (!$fids) {
			$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_MISSING_FILTER'), 'error');
			return false;
		}
		
		$cronurl = $data->get('cronurl');
		if (!$cronurl || $new_cron) {
			$cronurl = $this->newCronUrl($new_cron);
		}
		
		$params = JComponentHelper::getParams('com_jamegafilter');
		$params->set('time', $time);
		$params->set('fids', $fids);
		$params->set('cronurl', $cronurl);
		if ($reset_last_cron) {
			$params->set('last_cron', 0);
			$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_LAST_CRON_TIME_HAS_BEEN_RESET'), 'notice');
		}
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->update('#__extensions')
			->set($db->quoteName('params') . '=' . $db->quote($params->toString()))
			->where($db->quoteName('element') . '=' . $db->quote('com_jamegafilter'));
		$db->setQuery($query);
		if ($db->execute()) {
			$app->enqueueMessage( JText::_('COM_JAMEGAFILTER_SAVE_SUCCESS'));
			return true;
		} else {
			$app->enqueueMessage( JText::_('COM_JAMEGAFILTER_SAVE_FAILED'));
			return false;
		}
	}
	
	function newCronUrl() {
		$app = JFactory::getApplication();
		$app->enqueueMessage(JText::_('COM_JAMEGAFILTER_NEW_CRON_URL_CREATED'), 'notice');
		$config = JFactory::getConfig();
		$secret = md5( $config->get('secret') . time());
		return JUri::root() . 'index.php?option=com_jamegafilter&task=cron&token='.$secret;
	}
	
	function getItem() {
		$params = JComponentHelper::getParams('com_jamegafilter');
		if ($params->get('cronurl')) {
			return $params;
		}
	}

}